/*******************************************************************************
 * Copyright 2008 Seapine Software, Inc. All rights reserved.
 * 
 * IMPORTANT:  This Software is supplied to you by Seapine Software, Inc. (Seapine)
 * in consideration of your agreement to the following terms, and your use, installation,
 * modification or redistribution of this Software constitutes acceptance of these terms.
 * If you do not agree with these terms, please do not use, install, modify or redistribute
 * this Software.
 * 
 * In consideration of your agreement to abide by the following terms, and subject to these
 * terms, Seapine grants you a personal, non-exclusive license, under Seapine copyrights in
 * this original Seapine software (the Software), to use, reproduce, modify and redistribute
 * the Software, with or without modifications, in source and/or binary forms; provided that
 * if you redistribute the Software in its entirety and without modifications, you must retain
 * this notice and the following text and disclaimers in all such redistributions of the Software.
 * Neither the name, trademarks, service marks or logos of Seapine, Inc. may be used to endorse
 * or promote products derived from the Software without specific prior written permission from
 * Seapine.  Except as expressly stated in this notice, no other rights or licenses, express or
 * implied, are granted by Seapine herein, including but not limited to any patent rights that
 * may be infringed by your derivative works or by other works in which the Software may be
 * incorporated.
 * 
 * The Software is provided by Seapine on an "AS IS" basis.  SEAPINE MAKES NO WARRANTIES,
 * EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION THE IMPLIED WARRANTIES OF NON-INFRINGEMENT,
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE, REGARDING THE SOFTWARE OR ITS USE AND
 * OPERATION ALONE OR IN COMBINATION WITH YOUR PRODUCTS. 
 * 
 * IN NO EVENT SHALL SEAPINE BE LIABLE FOR ANY SPECIAL, INDIRECT, INCIDENTAL OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) ARISING IN ANY WAY OUT OF THE USE,
 * REPRODUCTION, MODIFICATION AND/OR DISTRIBUTION OF THE SOFTWARE, HOWEVER CAUSED AND WHETHER
 * UNDER THEORY OF CONTRACT, TORT (INCLUDING NEGLIGENCE), STRICT LIABILITY OR OTHERWISE, EVEN
 * IF SEAPINE HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ******************************************************************************/


using System;
using System.Collections.Generic;
using System.Text;

namespace TTArch
{
    class Program
    {
        
        

        static void Main(string[] args)
        {
            if (args.Length != 3)
            {
                Console.WriteLine("You must provide three arguments!");
            }
            else
            {

                string ttFilter = "";
                string ttDefNum = "";
                string appError = "";

                
                if (args[2].Contains("-f"))
                {
                    ttFilter = args[2].Substring(args[2].IndexOf("f") + 1, args[2].Length - 2);
                }
                else if (args[2].Contains("-n"))
                {
                    ttDefNum = args[2].Substring(args[2].IndexOf("n") + 1, args[2].Length - 2);
                }
                else
                {
                    Console.WriteLine("Third paramater not recognized");
                }
                if ((ttFilter == "") && (ttDefNum == ""))
                {
                    Console.WriteLine("You must provide a valid option!");
                }
                else
                {
                    Engine l_Engine = new Engine();
                    l_Engine.ttSrc = args[0];
                    l_Engine.ttDest = args[1];
                    if (ttFilter == "")
                    {
                        Console.WriteLine("Starting move of defect {0}", ttDefNum);
                        appError = l_Engine.MoveSingleDefect(Convert.ToInt64(ttDefNum));
                        if (appError == "")
                        {
                            Console.WriteLine("Defect {0} has been moved",ttDefNum);
                        }
                        else
                        {
                            Console.WriteLine("There was an error moving the defect.\n" + appError);
                        }                       
                         
                    }
                    else
                    {
                        Console.WriteLine("Starting move of defects based on filter {0}", ttFilter);
                        appError = l_Engine.MoveDefects(ttFilter);
                        if (appError == "")
                        {
                            Console.WriteLine("Defects based on filter {0} have been moved", ttFilter);
                        }
                        else
                        {
                            Console.WriteLine("There was an error moving the defects.\n" + appError);
                        }
                        
                    }

                }
            }
        }
       


    }
}
